git-rebase.shon commit Docs: send-email: Create logical groupings for man text (917f3e7)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_SPEC=
  32. git-sh-setup
  33set_reflog_action rebase
  34require_work_tree
  35cd_to_toplevel
  36
  37RESOLVEMSG="
  38When you have resolved this problem run \"git rebase --continue\".
  39If you would prefer to skip this patch, instead run \"git rebase --skip\".
  40To restore the original branch and stop rebasing run \"git rebase --abort\".
  41"
  42unset newbase
  43strategy=recursive
  44do_merge=
  45dotest="$GIT_DIR"/rebase-merge
  46prec=4
  47verbose=
  48git_am_opt=
  49
  50continue_merge () {
  51        test -n "$prev_head" || die "prev_head must be defined"
  52        test -d "$dotest" || die "$dotest directory does not exist"
  53
  54        unmerged=$(git ls-files -u)
  55        if test -n "$unmerged"
  56        then
  57                echo "You still have unmerged paths in your index"
  58                echo "did you forget to use git add?"
  59                die "$RESOLVEMSG"
  60        fi
  61
  62        cmt=`cat "$dotest/current"`
  63        if ! git diff-index --quiet --ignore-submodules HEAD --
  64        then
  65                if ! git commit --no-verify -C "$cmt"
  66                then
  67                        echo "Commit failed, please do not call \"git commit\""
  68                        echo "directly, but instead do one of the following: "
  69                        die "$RESOLVEMSG"
  70                fi
  71                printf "Committed: %0${prec}d " $msgnum
  72        else
  73                printf "Already applied: %0${prec}d " $msgnum
  74        fi
  75        git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
  76
  77        prev_head=`git rev-parse HEAD^0`
  78        # save the resulting commit so we can read-tree on it later
  79        echo "$prev_head" > "$dotest/prev_head"
  80
  81        # onto the next patch:
  82        msgnum=$(($msgnum + 1))
  83        echo "$msgnum" >"$dotest/msgnum"
  84}
  85
  86call_merge () {
  87        cmt="$(cat "$dotest/cmt.$1")"
  88        echo "$cmt" > "$dotest/current"
  89        hd=$(git rev-parse --verify HEAD)
  90        cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
  91        msgnum=$(cat "$dotest/msgnum")
  92        end=$(cat "$dotest/end")
  93        eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
  94        eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
  95        export GITHEAD_$cmt GITHEAD_$hd
  96        git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
  97        rv=$?
  98        case "$rv" in
  99        0)
 100                unset GITHEAD_$cmt GITHEAD_$hd
 101                return
 102                ;;
 103        1)
 104                git rerere
 105                die "$RESOLVEMSG"
 106                ;;
 107        2)
 108                echo "Strategy: $rv $strategy failed, try another" 1>&2
 109                die "$RESOLVEMSG"
 110                ;;
 111        *)
 112                die "Unknown exit code ($rv) from command:" \
 113                        "git-merge-$strategy $cmt^ -- HEAD $cmt"
 114                ;;
 115        esac
 116}
 117
 118move_to_original_branch () {
 119        test -z "$head_name" &&
 120                head_name="$(cat "$dotest"/head-name)" &&
 121                onto="$(cat "$dotest"/onto)" &&
 122                orig_head="$(cat "$dotest"/orig-head)"
 123        case "$head_name" in
 124        refs/*)
 125                message="rebase finished: $head_name onto $onto"
 126                git update-ref -m "$message" \
 127                        $head_name $(git rev-parse HEAD) $orig_head &&
 128                git symbolic-ref HEAD $head_name ||
 129                die "Could not move back to $head_name"
 130                ;;
 131        esac
 132}
 133
 134finish_rb_merge () {
 135        move_to_original_branch
 136        rm -r "$dotest"
 137        echo "All done."
 138}
 139
 140is_interactive () {
 141        test -f "$dotest"/interactive ||
 142        while :; do case $#,"$1" in 0,|*,-i|*,--interactive) break ;; esac
 143                shift
 144        done && test -n "$1"
 145}
 146
 147test -f "$GIT_DIR"/rebase-apply/applying &&
 148        die 'It looks like git-am is in progress. Cannot rebase.'
 149
 150is_interactive "$@" && exec git-rebase--interactive "$@"
 151
 152if test $# -eq 0
 153then
 154        test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
 155        test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
 156                die 'A rebase is in progress, try --continue, --skip or --abort.'
 157        die "No arguments given and $GIT_DIR/rebase-apply already exists."
 158fi
 159
 160while test $# != 0
 161do
 162        case "$1" in
 163        --continue)
 164                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 165                        die "No rebase in progress?"
 166
 167                git diff-files --quiet --ignore-submodules || {
 168                        echo "You must edit all merge conflicts and then"
 169                        echo "mark them as resolved using git add"
 170                        exit 1
 171                }
 172                if test -d "$dotest"
 173                then
 174                        prev_head=$(cat "$dotest/prev_head")
 175                        end=$(cat "$dotest/end")
 176                        msgnum=$(cat "$dotest/msgnum")
 177                        onto=$(cat "$dotest/onto")
 178                        continue_merge
 179                        while test "$msgnum" -le "$end"
 180                        do
 181                                call_merge "$msgnum"
 182                                continue_merge
 183                        done
 184                        finish_rb_merge
 185                        exit
 186                fi
 187                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 188                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 189                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 190                git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
 191                move_to_original_branch
 192                exit
 193                ;;
 194        --skip)
 195                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 196                        die "No rebase in progress?"
 197
 198                git reset --hard HEAD || exit $?
 199                if test -d "$dotest"
 200                then
 201                        git rerere clear
 202                        prev_head=$(cat "$dotest/prev_head")
 203                        end=$(cat "$dotest/end")
 204                        msgnum=$(cat "$dotest/msgnum")
 205                        msgnum=$(($msgnum + 1))
 206                        onto=$(cat "$dotest/onto")
 207                        while test "$msgnum" -le "$end"
 208                        do
 209                                call_merge "$msgnum"
 210                                continue_merge
 211                        done
 212                        finish_rb_merge
 213                        exit
 214                fi
 215                head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
 216                onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
 217                orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
 218                git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
 219                move_to_original_branch
 220                exit
 221                ;;
 222        --abort)
 223                test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
 224                        die "No rebase in progress?"
 225
 226                git rerere clear
 227                if test -d "$dotest"
 228                then
 229                        move_to_original_branch
 230                else
 231                        dotest="$GIT_DIR"/rebase-apply
 232                        move_to_original_branch
 233                fi
 234                git reset --hard $(cat "$dotest/orig-head")
 235                rm -r "$dotest"
 236                exit
 237                ;;
 238        --onto)
 239                test 2 -le "$#" || usage
 240                newbase="$2"
 241                shift
 242                ;;
 243        -M|-m|--m|--me|--mer|--merg|--merge)
 244                do_merge=t
 245                ;;
 246        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 247                --strateg=*|--strategy=*|\
 248        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 249                case "$#,$1" in
 250                *,*=*)
 251                        strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
 252                1,*)
 253                        usage ;;
 254                *)
 255                        strategy="$2"
 256                        shift ;;
 257                esac
 258                do_merge=t
 259                ;;
 260        -v|--verbose)
 261                verbose=t
 262                ;;
 263        --whitespace=*)
 264                git_am_opt="$git_am_opt $1"
 265                ;;
 266        -C*)
 267                git_am_opt="$git_am_opt $1"
 268                ;;
 269        -*)
 270                usage
 271                ;;
 272        *)
 273                break
 274                ;;
 275        esac
 276        shift
 277done
 278
 279# Make sure we do not have $GIT_DIR/rebase-apply
 280if test -z "$do_merge"
 281then
 282        if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
 283        then
 284                rmdir "$GIT_DIR"/rebase-apply
 285        else
 286                echo >&2 '
 287It seems that I cannot create a rebase-apply directory, and
 288I wonder if you are in the middle of patch application or another
 289rebase.  If that is not the case, please
 290        rm -fr '"$GIT_DIR"'/rebase-apply
 291and run me again.  I am stopping in case you still have something
 292valuable there.'
 293                exit 1
 294        fi
 295else
 296        if test -d "$dotest"
 297        then
 298                die "previous rebase directory $dotest still exists." \
 299                        'Try git rebase (--continue | --abort | --skip)'
 300        fi
 301fi
 302
 303# The tree must be really really clean.
 304git update-index --ignore-submodules --refresh || exit
 305diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
 306case "$diff" in
 307?*)     echo "cannot rebase: your index is not up-to-date"
 308        echo "$diff"
 309        exit 1
 310        ;;
 311esac
 312
 313# The upstream head must be given.  Make sure it is valid.
 314upstream_name="$1"
 315upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 316    die "invalid upstream $upstream_name"
 317
 318# Make sure the branch to rebase onto is valid.
 319onto_name=${newbase-"$upstream_name"}
 320onto=$(git rev-parse --verify "${onto_name}^0") || exit
 321
 322# If a hook exists, give it a chance to interrupt
 323if test -x "$GIT_DIR/hooks/pre-rebase"
 324then
 325        "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
 326                echo >&2 "The pre-rebase hook refused to rebase."
 327                exit 1
 328        }
 329fi
 330
 331# If the branch to rebase is given, that is the branch we will rebase
 332# $branch_name -- branch being rebased, or HEAD (already detached)
 333# $orig_head -- commit object name of tip of the branch before rebasing
 334# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 335switch_to=
 336case "$#" in
 3372)
 338        # Is it "rebase other $branchname" or "rebase other $commit"?
 339        branch_name="$2"
 340        switch_to="$2"
 341
 342        if git show-ref --verify --quiet -- "refs/heads/$2" &&
 343           branch=$(git rev-parse --verify "refs/heads/$2" 2>/dev/null)
 344        then
 345                head_name="refs/heads/$2"
 346        elif branch=$(git rev-parse --verify "$2" 2>/dev/null)
 347        then
 348                head_name="detached HEAD"
 349        else
 350                usage
 351        fi
 352        ;;
 353*)
 354        # Do not need to switch branches, we are already on it.
 355        if branch_name=`git symbolic-ref -q HEAD`
 356        then
 357                head_name=$branch_name
 358                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 359        else
 360                head_name="detached HEAD"
 361                branch_name=HEAD ;# detached
 362        fi
 363        branch=$(git rev-parse --verify "${branch_name}^0") || exit
 364        ;;
 365esac
 366orig_head=$branch
 367
 368# Now we are rebasing commits $upstream..$branch on top of $onto
 369
 370# Check if we are already based on $onto with linear history,
 371# but this should be done only when upstream and onto are the same.
 372mb=$(git merge-base "$onto" "$branch")
 373if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
 374        # linear history?
 375        ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
 376then
 377        # Lazily switch to the target branch if needed...
 378        test -z "$switch_to" || git checkout "$switch_to"
 379        echo >&2 "Current branch $branch_name is up to date."
 380        exit 0
 381fi
 382
 383if test -n "$verbose"
 384then
 385        echo "Changes from $mb to $onto:"
 386        # We want color (if set), but no pager
 387        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 388fi
 389
 390# Detach HEAD and reset the tree
 391echo "First, rewinding head to replay your work on top of it..."
 392git checkout -q "$onto^0" || die "could not detach HEAD"
 393git update-ref ORIG_HEAD $branch
 394
 395# If the $onto is a proper descendant of the tip of the branch, then
 396# we just fast forwarded.
 397if test "$mb" = "$branch"
 398then
 399        echo >&2 "Fast-forwarded $branch_name to $onto_name."
 400        move_to_original_branch
 401        exit 0
 402fi
 403
 404if test -z "$do_merge"
 405then
 406        git format-patch -k --stdout --full-index --ignore-if-in-upstream \
 407                "$upstream..$orig_head" |
 408        git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
 409        move_to_original_branch
 410        ret=$?
 411        test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
 412                echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
 413                echo $onto > "$GIT_DIR"/rebase-apply/onto &&
 414                echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
 415        exit $ret
 416fi
 417
 418# start doing a rebase with git-merge
 419# this is rename-aware if the recursive (default) strategy is used
 420
 421mkdir -p "$dotest"
 422echo "$onto" > "$dotest/onto"
 423echo "$onto_name" > "$dotest/onto_name"
 424prev_head=$orig_head
 425echo "$prev_head" > "$dotest/prev_head"
 426echo "$orig_head" > "$dotest/orig-head"
 427echo "$head_name" > "$dotest/head-name"
 428
 429msgnum=0
 430for cmt in `git rev-list --reverse --no-merges "$upstream..$orig_head"`
 431do
 432        msgnum=$(($msgnum + 1))
 433        echo "$cmt" > "$dotest/cmt.$msgnum"
 434done
 435
 436echo 1 >"$dotest/msgnum"
 437echo $msgnum >"$dotest/end"
 438
 439end=$msgnum
 440msgnum=1
 441
 442while test "$msgnum" -le "$end"
 443do
 444        call_merge "$msgnum"
 445        continue_merge
 446done
 447
 448finish_rb_merge